<!DOCTYPE html>
<html>
<head>
	<title>Vigenere</title>
</head>
<body>
	<script type="text/javascript">
// Vigenere cryptage

	message = "bonjour";
	cle = "abc";

	function decaler (lettre, cle) {

		lettre = lettre.charCodeAt(0);
		cle = cle.charCodeAt(0) % 26;

		if (estUneLettre(lettre)) { // si c'est une lettre, on décale le caractère
				lettre += cle;
				if (!estUneLettre(lettre)) { // si le caractère résultant n'est plus une lettre
					lettre -= 26; // on retire 26 et on retombe logiquement dans l'intervalle a-z (ou A-Z si c'était une majuscule)
				}
			} // si c'est pas une lettre, on ne le modifie pas

		return crypt = String.fromCharCode(lettre);
	}
		

		function estUneLettre(code) {
			return code > 64 && code < 91 // les maj
				|| code > 96 && code < 123; // les min

		}


function encode (message, cle) {
	var messCode ="";
	for (var i = 0, j = 0; i < message.length && j < cle.length; i++, j++) {
		messCode = messCode + decaler(message[i], cle[j]);
		while (message.length > cle.length) {
			cle += cle;
		}
	}
	return messCode;
}


























/* ETAPES
			// Etape par etape

			var message = prompt("Entrez votre message");
			var cle = prompt("Entrez votre cle");

			var cleCode = cle.charCodeAt(0);
			var messageCode = message.charCodeAt(0);
			var crypt = messageCode + cleCode;

			function encode () {
				// encoder chaque lettre du message
				for (





				// retourner sous forme de charactère le message encoder
				res = String.fromCharCode(crypt);
				return res;
			}
*/





/* PREMIER TEST

			// Tant que la longueur du message est supérieur a la longueur de la cle, on ajoute cle à cle

				var message = prompt("Entrez votre message");
				var cle = prompt("Entrez votre cle");

				var cleCode = cle.charCodeAt(0);
				var messageCode = message.charCodeAt(0);
				var crypt = messageCode + cleCode;

				
				alert(String.fromCharCode(crypt));

				function verif () {
					for (var i = 0; i < message.length; i++) {
						[i]
					}
				}
*/				


/* BOUT DE CODE

				while (message.length > cle.length) {
					cle += cle;
				}

				currentCharcode += 1;

*/





/* FONCTION DECALER

				function decaler(lettre, decalage) {

			// transforme la lettre en valeur
			var charCode = lettre.charCodeAt(0);

			// limitons le décalage à l'intervalle 0-25
			decalage = decalage % 26;

			// on vérifie si le caractère en cours est une lettre
			if (estUneLettre(charCode)) { // si c'est une lettre, on décale le caractère
				charCode += decalage;
				if (!estUneLettre(charCode)) { // si le caractère résultant n'est plus une lettre
					charCode -= 26; // on retire 26 et on retombe logiquement dans l'intervalle a-z (ou A-Z si c'était une majuscule)
				}
			} // si c'est pas une lettre, on ne le modifie pas

			return String.fromCharCode(charCode); // on retourne le caractère unicode correspondant à la valeur décalée
		}
				

			// Trouver le chiffre qui corespond a la cle

			// lancer la fonction Encodage avec un argument string et un argument Int

			*/
	</script>
</body>
</html>



